Index: .hgsubstate
===================================================================
--- .hgsubstate	(revision 1709)
+++ .hgsubstate	(revision 1742)
@@ -1,1 +1,1 @@
-7f6890267d808320431acd04f4dae19dcb027a80 inc/libs/clearbricks
+33139a996922b7a21b658961f8052c869bea60a1 inc/libs/clearbricks
Index: admin/blog_del.php
===================================================================
--- admin/blog_del.php	(revision 1399)
+++ admin/blog_del.php	(revision 1733)
@@ -61,7 +61,7 @@
 {
 	echo
-	'<p class="message">'.__('Warning').'</p>'.
+	'<div class="warning-msg"><p><strong>'.__('Warning').'</strong></p>'.
 	'<p>'.sprintf(__('You are about to delete the blog %s. Every entry, comment and category will be deleted.'),
-	'<strong>'.$blog_id.' ('.$blog_name.')</strong>').'</p>'.
+	'<strong>'.$blog_id.' ('.$blog_name.')</strong>').'</p></div>'.
 	'<p>'.__('Please give your password to confirm the blog deletion.').'</p>';
 	
Index: admin/blog_pref.php
===================================================================
--- admin/blog_pref.php	(revision 1698)
+++ admin/blog_pref.php	(revision 1746)
@@ -60,14 +60,8 @@
 
 # Language codes
-$langs = l10n::getISOcodes(1,1);
-foreach ($langs as $k => $v) {
-	$lang_avail = $v == 'en' || is_dir(DC_L10N_ROOT.'/'.$v);
-	$lang_combo[] = new formSelectOption($k,$v,$lang_avail ? 'avail10n' : '');
-}
+$lang_combo = dcAdminCombos::getAdminLangsCombo();
 
 # Status combo
-foreach ($core->getAllBlogStatus() as $k => $v) {
-	$status_combo[$v] = (string) $k;
-}
+$status_combo = dcAdminCombos::getBlogStatusescombo();
 
 # URL scan modes
@@ -327,9 +321,41 @@
 		echo
 		'<p><label for="blog_url" class="required"><abbr title="'.__('Required field').'">*</abbr> '.__('Blog URL:').'</label>'.
-		form::field('blog_url',30,255,html::escapeHTML($blog_url)).'</p>'.
+		form::field('blog_url',50,255,html::escapeHTML($blog_url)).'</p>'.
 		
 		'<p><label for="url_scan">'.__('URL scan method:').'</label>'.
-		form::combo('url_scan',$url_scan_combo,$blog_settings->system->url_scan).'</p>'.
-		
+		form::combo('url_scan',$url_scan_combo,$blog_settings->system->url_scan).'</p>';
+		
+		# Test URL of blog by testing it's ATOM feed
+		$file = $blog_url.$core->url->getURLFor('feed','atom');
+		$path = '';
+		$status = '404';
+		$content = '';
+		$client = netHttp::initClient($file,$path);
+		if ($client !== false) {
+			$client->setTimeout(4);
+			$client->setUserAgent($_SERVER['HTTP_USER_AGENT']);
+			$client->get($path);
+			$status = $client->getStatus();
+			$content = $client->getContent();
+		}
+		if ($status != '200') {
+			// Might be 404 (URL not found), 670 (blog not online), ...
+			echo
+			'<p class="form-note warn">'.
+			sprintf(__('The URL of blog or the URL scan method might not be well set (<code>%s</code> return a <strong>%s</strong> status).'),
+					$file,$status).
+			'</p>';
+		} else {
+			if (substr($content,0,6) != '<?xml ') {
+				// Not well formed XML feed
+				echo
+				'<p class="form-note warn">'.
+				sprintf(__('The URL of blog or the URL scan method might not be well set (<code>%s</code> does not return an ATOM feed).'),
+						$file).
+				'</p>';
+			}
+		}
+
+		echo
 		'<p><label for="blog_status">'.__('Blog status:').'</label>'.
 		form::combo('blog_status',$status_combo,$blog_status).'</p>';
Index: admin/categories.php
===================================================================
--- admin/categories.php	(revision 1662)
+++ admin/categories.php	(revision 1741)
@@ -114,15 +114,5 @@
 	dcPage::success(__('Categories have been successfully reordered.'));
 }
-
-$categories_combo = array();
-if (!$rs->isEmpty())
-{
-	while ($rs->fetch()) {
-		$catparents_combo[] = $categories_combo[] = new formSelectOption(
-			str_repeat('&nbsp;&nbsp;',$rs->level-1).($rs->level-1 == 0 ? '' : '&bull; ').html::escapeHTML($rs->cat_title),
-			$rs->cat_id
-		);
-	}
-}
+$categories_combo = dcAdminCombos::getCategoriesCombo($rs);
 
 echo
@@ -139,5 +129,4 @@
 	echo
 	'<form action="categories.php" method="post" id="form-categories">'.
-	'<h3>'.__('List of blog\'s categories').'</h3>'.
 	'<div id="categories">';
 
@@ -180,5 +169,5 @@
 	'<p class="col right" id="mov-cat">'.
 	'<label for="mov_cat" class="classic">'.__('Category which will receive entries of deleted categories:').'</label> '.
-	form::combo('mov_cat',array_merge(array(__('(No cat)') => ''),$categories_combo),'','').
+	form::combo('mov_cat',$categories_combo,'','').
 	'</p>'.
 	'<p class="right">'.
Index: admin/comment.php
===================================================================
--- admin/comment.php	(revision 1553)
+++ admin/comment.php	(revision 1719)
@@ -26,8 +26,7 @@
 $comment_spam_status = '';
 
+
 # Status combo
-foreach ($core->blog->getAllCommentStatus() as $k => $v) {
-	$status_combo[$v] = (string) $k;
-}
+$status_combo = dcAdminCombos::getCommentStatusescombo();
 
 # Adding comment
Index: admin/comments.php
===================================================================
--- admin/comments.php	(revision 1528)
+++ admin/comments.php	(revision 1719)
@@ -28,10 +28,9 @@
 # Creating filter combo boxes
 # Filter form we'll put in html_block
-$status_combo = array(
-'-' => ''
-);
-foreach ($core->blog->getAllCommentStatus() as $k => $v) {
-	$status_combo[$v] = (string) $k;
-}
+$status_combo = array_merge(
+	array('-' => ''),
+	dcAdminCombos::getCommentStatusescombo()
+);
+
 
 $type_combo = array(
Index: admin/index.php
===================================================================
--- admin/index.php	(revision 1699)
+++ admin/index.php	(revision 1741)
@@ -144,10 +144,10 @@
 		if ($feed)
 		{
-			$latest_news = '<h3>'.__('Latest news').'</h3><dl id="news">';
+			$latest_news = '<h3>'.__('Dotclear news').'</h3><dl id="news">';
 			$i = 1;
 			foreach ($feed->items as $item)
 			{
-				$dt = isset($item->link) ? '<a href="'.$item->link.'" title="'.$item->title.' '.__('(external link)').'">'.
-					$item->title.'</a>' : $item->title;
+				$dt = isset($item->link) ? '<a href="'.$item->link.'" title="'.$item->title.' ('.__('new window').')">'.
+					$item->title.' <img src="images/outgoing-blue.png" alt="" /></a>' : $item->title;
 			
 				if ($i < 3) {
@@ -179,5 +179,6 @@
 	
 		foreach ($__resources['doc'] as $k => $v) {
-			$doc_links .= '<li><a href="'.$v.'" title="'.$k.' '.__('(external link)').'">'.$k.'</a></li>';
+			$doc_links .= '<li><a href="'.$v.'" title="'.$k.' ('.__('new window').')">'.$k.
+			' <img src="images/outgoing-blue.png" alt="" /></a></li>';
 		}
 	
@@ -222,5 +223,5 @@
 		'<a href="update.php?hide_msg=1">'.__('Remind me later').'</a>'.
 		($version_info ? ' </p>'.
-		'<p><a href="'.$version_info.'" class="info">'.__('information about this version').'</a>' : '').'</p>'.
+		'<p><a href="'.$version_info.'" class="updt-info">'.__('information about this version').'</a>' : '').'</p>'.
 		'</div>';
 	}
@@ -257,15 +258,23 @@
 
 # Check cache directory
-if (!is_dir(DC_TPL_CACHE)) {
-	$err[] = '<p>'.sprintf(__('Cache directory %s does not exist.'),DC_TPL_CACHE).'</p>';
-} else if (!is_writable(DC_TPL_CACHE)) {
-	$err[] = '<p>'.sprintf(__('Cache directory %s is not writable.'),DC_TPL_CACHE).'</p>';
+if ( $core->auth->isSuperAdmin() ) {
+	if (!is_dir(DC_TPL_CACHE) || !is_writable(DC_TPL_CACHE)) {
+		$err[] = '<p>'.__("The cache directory does not exist or is not writable. You must create this directory with sufficient rights and affect this location to \"DC_TPL_CACHE\" in inc/config.php file.").'</p>';
+	}
+} else {
+	if (!is_dir(DC_TPL_CACHE) || !is_writable(DC_TPL_CACHE)) {
+		$err[] = '<p>'.__("The cache directory does not exist or is not writable. You should contact your administrator.").'</p>';
+	}
 }
 
 # Check public directory
-if (!is_dir($core->blog->public_path)) {
-	$err[] = '<p>'.sprintf(__('Directory %s does not exist.'),$core->blog->public_path).'</p>';
-} else if (!is_writable($core->blog->public_path)) {
-	$err[] = '<p>'.sprintf(__('Directory %s is not writable.'),$core->blog->public_path).'</p>';
+if ( $core->auth->isSuperAdmin() ) {
+	if (!is_dir($core->blog->public_path) || !is_writable($core->blog->public_path)) {
+		$err[] = '<p>'.__("There is no writable directory /public/ at the location set in about:config \"public_path\". You must create this directory with sufficient rights (or change this setting).").'</p>';
+	}
+} else {
+	if (!is_dir($core->blog->public_path) || !is_writable($core->blog->public_path)) {
+		$err[] = '<p>'.__("There is no writable root directory for the media manager. You should contact your administrator.").'</p>';
+	}
 }
 
@@ -293,25 +302,4 @@
 	echo '</ul></div>';
 }
-
-# Dashboard columns (processed first, as we need to know the result before displaying the icons.)
-$dashboardItems = '';
-
-# Dotclear updates notifications
-if ($core->auth->isSuperAdmin() && is_readable(DC_DIGESTS))
-{
-	$updater = new dcUpdate(DC_UPDATE_URL,'dotclear',DC_UPDATE_VERSION,DC_TPL_CACHE.'/versions');
-	$new_v = $updater->check(DC_VERSION);
-	$version_info = $new_v ? $updater->getInfoURL() : '';
-	
-	if ($updater->getNotify() && $new_v) {
-		$dashboardItems .=
-		'<div id="upg-notify" class="static-msg"><p>'.sprintf(__('Dotclear %s is available!'),$new_v).'</p> '.
-		'<ul><li><strong><a href="update.php">'.sprintf(__('Upgrade now'),$new_v).'</a></strong>'.
-		'</li><li><a href="update.php?hide_msg=1">'.__('Remind me later').'</a>'.
-		($version_info ? ' </li><li>'.sprintf(__('<a href=\"%s\">Information about this version</a>.'),$version_info) : '').
-		'</li></ul></div>';
-	}
-}
-
 # Errors modules notifications
 if ($core->auth->isSuperAdmin())
@@ -323,10 +311,12 @@
 	
 	if (count($list) > 0) {
-		$dashboardItems .=
-		'<div id="module-errors" class="error"><p>'.__('Some plugins are installed twice:').'</p> '.
+		echo 
+		'<div class="error" id="module-errors" class="error"><p>'.__('Some plugins are installed twice:').'</p> '.
 		'<ul>'.implode("\n",$list).'</ul></div>';
 	}
-	
-}
+}
+
+# Dashboard columns (processed first, as we need to know the result before displaying the icons.)
+$dashboardItems = '';
 
 foreach ($__dashboard_items as $i)
@@ -334,5 +324,5 @@
 	if ($i->count() > 0)
 	{
-		$dashboardItems .= '<div class="db-item">';
+		$dashboardItems .= '<div class="box">';
 		foreach ($i as $v) {
 			$dashboardItems .= $v;
@@ -343,5 +333,5 @@
 
 # Dashboard icons
-echo '<div id="dashboard-main"'.($dashboardItems ? '' : ' class="fullwidth"').'><div id="icons">';
+echo '<div id="dashboard-main"><div id="icons">';
 foreach ($__dashboard_icons as $i)
 {
@@ -356,16 +346,7 @@
 	{
 		# Getting categories
-		$categories_combo = array(__('(No cat)') => '');
-		try {
-			$categories = $core->blog->getCategories(array('post_type'=>'post'));
-			if (!$categories->isEmpty()) {
-				while ($categories->fetch()) {
-					$catparents_combo[] = $categories_combo[] = new formSelectOption(
-						str_repeat('&nbsp;&nbsp;',$categories->level-1).($categories->level-1 == 0 ? '' : '&bull; ').html::escapeHTML($categories->cat_title),
-						$categories->cat_id
-					);
-				}
-			}
-		} catch (Exception $e) { }
+		$categories_combo = dcAdminCombos::getCategoriesCombo(
+			$core->blog->getCategories(array('post_type'=>'post'))
+		);
 	
 		echo
@@ -414,5 +395,5 @@
 	if ($i->count() > 0)
 	{
-		$dashboardContents .= '<div>';
+		$dashboardContents .= '<div class="box">';
 		foreach ($i as $v) {
 			$dashboardContents .= $v;
@@ -421,9 +402,18 @@
 	}
 }
-echo ($dashboardContents ? '<div id="dashboard-contents">'.$dashboardContents.'</div>' : '');
+
+$class = ' '.(($dashboardItems != '') && ($dashboardContents != '') ? 'two-boxes' : 'one-box');
+
+if ($dashboardContents != '' || $dashboardItems != '') {
+	echo 
+	'<hr />'.
+	'<div id="dashboard-boxes">';
+		echo ($dashboardContents ? '<div class="db-contents'.$class.'">'.$dashboardContents.'</div>' : '');
+		echo ($dashboardItems ? '<div class="db-items'.$class.'">'.$dashboardItems.'</div>' : '');
+	echo
+	'</div>';		
+}
 
 echo '</div>';
-
-echo ($dashboardItems ? '<div id="dashboard-items">'.$dashboardItems.'</div>' : '');
 
 dcPage::close();
Index: admin/install/check.php
===================================================================
--- admin/install/check.php	(revision 1179)
+++ admin/install/check.php	(revision 1743)
@@ -49,5 +49,5 @@
 	}
 	
-	if ($con->driver() == 'mysql')
+	if ($con->driver() == 'mysql' || $con->driver() == 'mysqli')
 	{
 		if (version_compare($con->version(),'4.1','<'))
Index: admin/install/wizard.php
===================================================================
--- admin/install/wizard.php	(revision 1399)
+++ admin/install/wizard.php	(revision 1744)
@@ -55,5 +55,5 @@
 }
 
-$DBDRIVER = !empty($_POST['DBDRIVER']) ? $_POST['DBDRIVER'] : 'mysql';
+$DBDRIVER = !empty($_POST['DBDRIVER']) ? $_POST['DBDRIVER'] : (function_exists('mysqli_connect') ? 'mysqli' : 'mysql');
 $DBHOST = !empty($_POST['DBHOST']) ? $_POST['DBHOST'] : '';
 $DBNAME = !empty($_POST['DBNAME']) ? $_POST['DBNAME'] : '';
@@ -179,5 +179,5 @@
 '<form action="wizard.php" method="post">'.
 '<p><label class="required" for="DBDRIVER"><abbr title="'.__('Required field').'">*</abbr> '.__('Database type:').'</label> '.
-form::combo('DBDRIVER',array('MySQL'=>'mysql','PostgreSQL'=>'pgsql'),$DBDRIVER).'</p>'.
+form::combo('DBDRIVER',array(__('MySQL (deprecated)')=>'mysql',__('MySQLi')=>'mysqli',__('PostgreSQL')=>'pgsql'),$DBDRIVER).'</p>'.
 '<p><label for="DBHOST">'.__('Database Host Name:').'</label> '.
 form::field('DBHOST',30,255,html::escapeHTML($DBHOST)).'</p>'.
Index: admin/js/_media.js
===================================================================
--- admin/js/_media.js	(revision 1461)
+++ admin/js/_media.js	(revision 1724)
@@ -1,124 +1,132 @@
+(function($) {
+	$.fn.enhancedUploader = function() {
+		return this.each(function() {
+			var me = $(this);
+
+			function enableButton(button) {
+				button.prop('disabled',false).removeClass('disabled');
+			}
+
+			function disableButton(button) {
+				button.prop('disabled',true).addClass('disabled');
+			}
+			
+			function displayMessageInQueue(n) {
+				var msg = '';
+				if (n==1) {
+					msg = dotclear.jsUpload.msg.file_in_queue;
+				} else if (n>1) {
+					msg = dotclear.jsUpload.msg.files_in_queue;
+					msg = msg.replace(/%d/,n);
+				} else {
+					msg = dotclear.jsUpload.msg.no_file_in_queue;
+				}
+				$('.queue-message',me).html(msg);
+			}
+			
+			$('.button.add').click(function(e) {
+				// Use the native click() of the file input.
+				$('#upfile').click();
+				e.preventDefault();
+			});
+			
+			$('.button.cancel', '#fileupload .fileupload-buttonbar').click(function(e) {
+				$('.button.cancel','#fileupload .fileupload-buttonbar').hide();
+				disableButton($('.button.start','#fileupload .fileupload-buttonbar'));
+				displayMessageInQueue(0);
+			});
+			
+			$('.cancel').live('click', function(e) {
+				if ($('.fileupload-ctrl .files .template-upload', me).length==0) {
+					$('.button.cancel','#fileupload .fileupload-buttonbar').hide();
+					disableButton($('.button.start','#fileupload .fileupload-buttonbar'));
+				}
+				displayMessageInQueue($('.files .template-upload',me).length);
+			});
+			
+			$('.button.clean', me).click(function(e) {
+				$('.fileupload-ctrl .files .template-download', me).slideUp(500, function() {
+					$(this).remove();
+				});
+				$(this).hide();
+				e.preventDefault();
+			});
+			
+			$(me).fileupload({
+				url: $(me).attr('action'),
+				autoUpload: false,
+				sequentialUploads: true,
+				uploadTemplateId: null,
+				downloadTemplateId: null,
+				uploadTemplate: template_upload,
+				downloadTemplate: template_download
+			}).bind('fileuploadadd', function(e, data) {
+				$('.button.cancel','#fileupload .fileupload-buttonbar').show();
+				enableButton($('.button.start','#fileupload .fileupload-buttonbar'));
+			}).bind('fileuploadadded', function(e, data) {
+				displayMessageInQueue($('.files .template-upload',me).length);
+			}).bind('fileuploaddone', function(e, data) {
+				if (data.result.files[0].html !==undefined) {
+					$('.media-list p.clear').before(data.result.files[0].html);
+				}
+				$('.button.clean',me).show();
+			}).bind('fileuploadalways', function(e, data) {
+				displayMessageInQueue($('.files .template-upload',me).length);
+				if ($('.fileupload-ctrl .files .template-upload',me).length==0) {
+					$('.button.cancel','#fileupload .fileupload-buttonbar').hide();
+					disableButton($('.button.start','#fileupload .fileupload-buttonbar'));
+				}
+			});
+			
+			var $container = $(me).parent();
+			var $msg,label;
+
+			if ($container.hasClass('enhanced_uploader')) {
+				$msg = dotclear.msg.enhanced_uploader_disable;
+				label = dotclear.jsUpload.msg.choose_files;
+				$(me).fileupload({disabled:false});
+				displayMessageInQueue(0);
+				disableButton($('.button.start','#fileupload .fileupload-buttonbar'));
+			} else {
+				$msg = dotclear.msg.enhanced_uploader_activate;
+				label = dotclear.jsUpload.msg.choose_file;
+			}
+
+			$('<p class="clear"><a class="enhanced-toggle" href="#">' + $msg + '</a></p>').click(function() {
+				if ($container.hasClass('enhanced_uploader')) {
+					$msg = dotclear.msg.enhanced_uploader_activate;
+					label = dotclear.jsUpload.msg.choose_file;
+					$('#upfile').attr('multiple', false);
+					enableButton($('.button.start','#fileupload .fileupload-buttonbar'));
+					
+					// when a user has clicked enhanced_uploader, and has added files
+					// We must remove files in table
+					$('.files .upload-file', me).remove();
+					$('.button.cancel,.button.clean','#fileupload .fileupload-buttonbar').hide();
+					$(me).fileupload({disabled:true});
+					$('.queue-message',me).html('').hide();
+				} else {
+					$msg = dotclear.msg.enhanced_uploader_disable;
+					label = dotclear.jsUpload.msg.choose_files;
+					$('#upfile').attr('multiple', true);
+					var startButton = $('.button.start','#fileupload .fileupload-buttonbar');
+					disableButton(startButton);
+					startButton.show();
+					$(me).fileupload({disabled:false});
+					$('.queue-message',me).show();
+					displayMessageInQueue(0);
+				}
+				$(this).find('a').text($msg);
+				$('.add-label', me).text(label);
+				
+				$container.toggleClass('enhanced_uploader');
+			}).appendTo(me);
+		});
+	};
+})(jQuery);
+
+
 $(function() {
-	if ($('#fileupload').length==0) {
-		return;
-	}
-
-	function enableButton(button) {
-		button.prop('disabled',false).removeClass('disabled');
-	}
-
-	function disableButton(button) {
-		button.prop('disabled',true).addClass('disabled');
-	}
-
-	function displayMessageInQueue(n) {
-		var msg = '';
-		if (n==1) {
-			msg = dotclear.jsUpload.msg.file_in_queue;
-		} else if (n>1) {
-			msg = dotclear.jsUpload.msg.files_in_queue;
-			msg = msg.replace(/%d/,n);
-		} else {
-			msg = dotclear.jsUpload.msg.no_file_in_queue;
-		}
-		$('.queue-message','#fileupload').html(msg);
-	}
-
-	$('.button.add').click(function(e) {
-		// Use the native click() of the file input.
-		$('#upfile').click();
-		e.preventDefault();
-	});
-
-	$('.button.cancel', '#fileupload .fileupload-buttonbar').click(function(e) {
-		$('.button.cancel','#fileupload .fileupload-buttonbar').hide();
-		disableButton($('.button.start','#fileupload .fileupload-buttonbar'));
-		displayMessageInQueue(0);
-	});
-
-	$('.cancel').live('click', function(e) {
-		if ($('.fileupload-ctrl .files .template-upload', '#fileupload').length==0) {
-			$('.button.cancel','#fileupload .fileupload-buttonbar').hide();
-			disableButton($('.button.start','#fileupload .fileupload-buttonbar'));
-		}
-		displayMessageInQueue($('.files .template-upload','#fileupload').length);
-	});
-
-	$('.button.clean', '#fileupload').click(function(e) {
-		$('.fileupload-ctrl .files .template-download', '#fileupload').slideUp(500, function() {
-			$(this).remove();
-		});
-		$(this).hide();
-		e.preventDefault();
-	});
-
-	$('#fileupload').fileupload({
-		url: $('#fileupload').attr('action'),
-		autoUpload: false,
-		sequentialUploads: true,
-		uploadTemplateId: null,
-		downloadTemplateId: null,
-		uploadTemplate: template_upload,
-		downloadTemplate: template_download
-	}).bind('fileuploadadd', function(e, data) {
-		$('.button.cancel','#fileupload .fileupload-buttonbar').show();
-		enableButton($('.button.start','#fileupload .fileupload-buttonbar'));
-	}).bind('fileuploadadded', function(e, data) {
-		displayMessageInQueue($('.files .template-upload','#fileupload').length);
-	}).bind('fileuploaddone', function(e, data) {
-		if (data.result.files[0].html !==undefined) {
-			$('.media-list p.clear').before(data.result.files[0].html);
-		}
-		$('.button.clean','#fileupload').show();
-	}).bind('fileuploadalways', function(e, data) {
-		displayMessageInQueue($('.files .template-upload','#fileupload').length);
-		if ($('.fileupload-ctrl .files .template-upload','#fileupload').length==0) {
-			$('.button.cancel','#fileupload .fileupload-buttonbar').hide();
-			disableButton($('.button.start','#fileupload .fileupload-buttonbar'));
-		}
-	});
-
-	var $container = $('#fileupload').parent().parent();
-	var $msg,label;
-
-	if ($container.hasClass('enhanced_uploader')) {
-		$msg = dotclear.msg.enhanced_uploader_disable;
-		label = dotclear.jsUpload.msg.choose_files;
-		$('#fileupload').fileupload({disabled:false});
-		displayMessageInQueue(0);
-		disableButton($('.button.start','#fileupload .fileupload-buttonbar'));
-	} else {
-		$msg = dotclear.msg.enhanced_uploader_activate;
-		label = dotclear.jsUpload.msg.choose_file;
-	}
-
-	$('<p class="clear"><a class="enhanced-toggle" href="#">' + $msg + '</a></p>').click( function() {
-		if ($container.hasClass('enhanced_uploader')) {
-			$msg = dotclear.msg.enhanced_uploader_activate;
-			label = dotclear.jsUpload.msg.choose_file;
-			$('#upfile').attr('multiple', false);
-
-			// when a user has clicked enhanced_uploader, and has added files
-			// We must remove files in table
-			$('.files .upload-file', '#fileupload').remove();
-			$('.button.cancel,.button.clean','#fileupload .fileupload-buttonbar').hide();
-			$('#fileupload').fileupload({disabled:true});
-			$('.queue-message','#fileupload').html('').hide();
-		} else {
-			$msg = dotclear.msg.enhanced_uploader_disable;
-			label = dotclear.jsUpload.msg.choose_files;
-			$('#upfile').attr('multiple', true);
-			var startButton = $('.button.start','#fileupload .fileupload-buttonbar');
-			disableButton(startButton);
-			startButton.show();
-			$('#fileupload').fileupload({disabled:false});
-			$('.queue-message','#fileupload').show();
-			displayMessageInQueue(0);
-		}
-		$(this).find('a').text($msg);
-		$('.add-label', '#fileupload').text(label);
-
-		$container.toggleClass('enhanced_uploader');
-	}).appendTo($('#fileupload'));
+	$('#fileupload').enhancedUploader();
 
 	// Replace remove links by a POST on hidden form
